scala.util.control

# Exception

#### object Exception extends AnyRef

Classes representing the components of exception handling. Each class is independently composable. Some example usages:

     import scala.util.control.Exception._
     import java.net._

     val s = "http://www.scala-lang.org/"
     val x1 = catching(classOf[MalformedURLException]) opt new URL(s)
     val x2 = catching(classOf[MalformedURLException], classOf[NullPointerException]) either new URL(s)

Source
  Exception.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Exception
2. AnyRef
3. Any

Visibility

1. Public
2. All

### Type Members

1. #### class By[T, R] extends AnyRef

   Returns a partially constructed Catch object, which you must give an exception handler function as an argument to "by".

2. #### class Catch[+T] extends Described

   A container class for catch/finally logic.

3. #### type Catcher[+T] = PartialFunction[Throwable, T]

4. #### trait Described extends AnyRef

5. #### class Finally extends Described

   A container class for finally code.

6. #### class Try[+T] extends AnyRef

   A container class for Try logic

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def allCatch[T]: Catch[T]

   A Catch object which catches everything.

7. #### final def allCatcher[T]: Catcher[T]

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def catching[T](c: Catcher[T]): Catch[T]

10. #### def catching[T](exceptions: Class[_]*): Catch[T]

    Creates a Catch object which will catch any of the supplied exceptions.

    Creates a Catch object which will catch any of the supplied exceptions. Since the returned Catch object has no specific logic defined and will simply rethrow the exceptions it catches, you will typically want to call "opt" or "either" on the return value, or assign custom logic by calling "withApply".

    Note that Catch objects automatically rethrow ControlExceptions and others which should only be caught in exceptional circumstances. If you really want to catch exactly what you specify, use "catchingPromiscuously" instead.

11. #### def catchingPromiscuously[T](c: Catcher[T]): Catch[T]

12. #### def catchingPromiscuously[T](exceptions: Class[_]*): Catch[T]

    Creates a Catch object which will catch any of the supplied exceptions.

    Creates a Catch object which will catch any of the supplied exceptions. Unlike "catching" which filters out those in shouldRethrow, this one will catch whatever you ask of it: ControlThrowable, InterruptedException, OutOfMemoryError, you name it.

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def failAsValue[T](exceptions: Class[_]*)(value: ⇒ T): Catch[T]

    Creates a Catch object which maps all the supplied exceptions to the given value.

17. #### def failing[T](exceptions: Class[_]*): Catch[Option[T]]

    Creates a Catch object which maps all the supplied exceptions to 'None'.

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

19. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def handling[T](exceptions: Class[_]*): By[(Throwable) ⇒ T, Catch[T]]

21. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

22. #### def ignoring(exceptions: Class[_]*): Catch[Unit]

    Creates a Catch object which catches and ignores any of the supplied exceptions.

23. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

24. #### def mkCatcher[Ex <: Throwable, T](isDef: (Ex) ⇒ Boolean, f: (Ex) ⇒ T)(implicit arg0: ClassManifest[Ex]): Catcher[T]

25. #### def mkThrowableCatcher[T](isDef: (Throwable) ⇒ Boolean, f: (Throwable) ⇒ T): Catcher[T]

26. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

27. #### final val noCatch: Catch[Nothing]

    The empty Catch object.

28. #### final val nothingCatcher: Catcher[Nothing]

29. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

30. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### def shouldRethrow(x: Throwable): Boolean

    !!! Not at all sure of every factor which goes into this, and/or whether we need multiple standard variations.

32. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

33. #### implicit def throwableSubtypeToCatcher[Ex <: Throwable, T](pf: PartialFunction[Ex, T])(implicit arg0: ClassManifest[Ex]): Catcher[T]

34. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

35. #### def ultimately[T](body: ⇒ Unit): Catch[T]

    Returns a Catch object with no catch logic and the argument as Finally.

36. #### def unwrapping[T](exceptions: Class[_]*): Catch[T]

    Creates a Catch object which unwraps any of the supplied exceptions.

37. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

38. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

39. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from AnyRef

### Inherited from Any